<script setup>
import { useMetadataStore } from "@/stores/useMetadataStore";
import { useNodeStore } from "@/stores/useNodeStore";
import { useWorkspaceStore } from "@/stores/useWorkspaceStore";

const props = defineProps({
  node: {
    type: Object,
    required: true,
  },
  active: {
    type: Boolean,
    required: true,
  },
  ml: {
    required: false,
    type: Number,
    default: 0,
  },
  addMember: {
    required: false,
    type: Boolean,
    default: false,
  },
  color: {
    required: false,
    type: String,
  },
});
const nodeStore = useNodeStore();
const workspaceStore = useWorkspaceStore();
const metadataStore = useMetadataStore();
const route = useRoute();

function incrementML() {
  return props.ml + 20;
}

const dialogConfirmLeave = ref(false);
const tempItem = ref({});

async function openNode(item) {
  if (metadataStore.unsavedMetadata.node === true) {
    dialogConfirmLeave.value = true;
    tempItem.value = item;
  } else {
    item.opened = !item.opened;
    await nodeStore.saveAndRefresh();
    if (item.opened) {
      await nodeStore.addNodeToTree(item);
    }
    navigateTo(`/${workspaceStore.currentWSlug}/${item.id}`);
  }
}

async function joinNode() {
  const { data: session } = useAuth();
  const user = session.value?.user;
  await nodeStore.createMember(user.id, "owner");
  nodeStore.nodes.get(props.node.id).value.userRole = "owner";
}

function confirmLeave(response, item) {
  dialogConfirmLeave.value = false;
  if (response === "yes") {
    navigateTo(`/${workspaceStore.currentWSlug}/${item.id}`);
    metadataStore.unsavedMetadata.node = false;
    tempItem.value = {};
  }
}
</script>

<template>
  <div :style="{ 'margin-left': `${ml}px` }">
    <v-dialog
      v-model="dialogConfirmLeave"
      persistent
      max-width="500px"
    >
      <v-card>
        <v-card-title class="headline">
          Unsaved metadata changes
        </v-card-title>
        <v-card-text>
          You have unsaved changes. Do you really want to leave this page?
        </v-card-text>
        <v-card-actions>
          <v-spacer />
          <v-btn @click="confirmLeave('no', node)">
            No
          </v-btn>
          <v-btn color="error" @click="confirmLeave('yes', node)">
            Yes
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
    <div
      class="d-flex pointer-cursor hover"
      :class="color ? color : addMember ? 'text-grey-darken-1' : ''"
      @click="openNode(node)"
    >
      <div>
        <v-icon
          :icon="node?.opened ? 'mdi-chevron-down' : 'mdi-chevron-right'"
          size="small"
          color="grey"
        />
      </div>
      <div class="me-2">
        <v-icon :icon="node?.type?.icon" size="small" />
      </div>
      <div class="me-auto text-truncate" :class="[{ 'font-weight-bold': active }]">
        {{ node && node.title ? node.title : "Untitled" }}
      </div>
      <v-tooltip :disabled="!addMember">
        <template v-slot:activator="{ props: slotProps }">
          <span v-bind="slotProps">
            <v-icon
              v-if="addMember"
              icon="mdi-account-plus"
              size="small"
              color="black"
              @click="joinNode"
            />
          </span>
        </template>
        <span>Add yourself to the {{ node?.type?.name }} as owner.</span>
      </v-tooltip>
    </div>
    <div v-if="node && node.children && node.children.size > 0 && node.opened">
      <NodeMenuItem
        v-for="(child, key) in node.children.values()"
        :key="key"
        :node="child.value"
        :ml="incrementML()"
        :active="child.value.id === route.params.nid"
        :class="color ? color : addMember ? 'text-grey-darken-1' : ''"
        @open="openNode(child.value)"
      />
    </div>
  </div>
</template>

<style>
.pointer-cursor {
  cursor: pointer;
}

.hover:hover {
  background-color: #f2f2f2;
}
</style>
